Dom0 Kernels for Xen

From Xen

(Redirected from XenDom0Kernels)
Jump to: navigation, search

If you don't know what "dom0" or a "dom0 kernel" is, take look at the detailed explanation here.

This page contains information on Xen dom0 support, if you are looking for information on guest (domU) support see DomU_Support_for_Xen.

Contents

Choosing a dom0 kernel

If your Linux distribution includes Xen Project and dom0 kernel it is recommended to use them. This provides benefits such as ease of install, good integration with the distribution, support from the distribution, and provision of security updates.

Xen Project PV domU kernel versions can be different from dom0 kernel versions. There's no need to upgrade domU kernel when you upgrade Xen hypervisor and/or dom0 kernel. The Xen Project hypervisor is backwards compatible, ie. it supports older domU kernels. If your domU distribution includes a Xen Project domU kernel, it's usually best to use it and not compile your own domU kernel.

Also please notice that mainline vanilla Linux kernel already supports Xen Project. Instructions how to configure and build a Linux kernel for Dom0 and DomU support are reported here: Mainline_Linux_Kernel_Configs .

Linux Distributions which have a Xen Project Dom0 kernel

Distributions Versions Docs
Alpine Linux 2.4.x (2012-05-02)[2] and newer Doc
CentOS and other RHEL clones 5.x Doc
CentOS 6.4+ 6.4 and newer, use Xen4CentOS (see announcement) Doc
Debian 4.0 (Etch), 5.0 (Lenny), 6.0 (Squeeze)[1], 7 (Wheezy)[1] Doc
Fedora Full support from Fedora 16 onwards (see here) Doc
Mageia All versions Doc
Ubuntu All versions since 11.10 [1] Doc
OpenSUSE All versions since 11 Doc
Oracle VM for x86 (OVS) All versions Doc
Redhat Enterprise Linux (RHEL) 5.x only Doc
SUSE Linux Enterprise (SLE) All versions since 11 Doc
XenServer All versions, but open source from XenServer 6.2. Before that XCP was available as an open source subset of XenServer. Doc


1) Please note that this kernel requires Xen >= 4.0.
2) See wiki for more info
3) Dom0 kernel provided via this (unofficial) repository
4) Based on Ubuntu 12.04 and 12.10 resp.

Xen Project Dom0 support in BSDs and other Unix systems

This list is currently incomplete. We are in the process of verifying support for other Unixes.

Distributions Versions Docs
NetBSD 5.1, 6 [1] [2] [5] Doc
OpenSolaris 2009.06 [3] Doc
Illumos Incomplete [4] Doc


1) See NetBSD Xen Project HowTo for more information
2) See NetBSD Xen Project User Guide
3) OpenSolaris has been discontinued by Oracle, but Xen Project dom0 support is present in the latest 2009.06 release and later development snapshots before OpenSolaris was discontinued.
4) Illumos [1] is a fork of OpenSolaris, and Xen Project dom0 support is present in the Illumos sources, but it's currently unmaintained and untested. Interested developers should be able to make it work again, because it was working earlier in OpenSolaris.
5) See NetBSD Xen Project News

Mini-OS

Mini-OS is a tiny OS kernel distributed with the Xen Project hypervisor sources (see extras/mini-os in the Xen Project source code). It is mainly used as operating system for stub domains that are used for Dom0 Disaggregation.

FAQ

Please see XenKernelFeatures for more information about available features in different Xen Project-enabled kernels.

Q: I've seen mentions of 'pv_ops' and 'xenlinux' kernels. Which one should I choose?

Simple answer: pv_ops. Xen Project 4.0 switched to using Linux pv_ops based dom0 kernel as a default, and it's the most up-to-date and is undergoing active development.

Longer answer: There are two different types of Xen Project dom0 capable kernels available today:

  • pvops kernels, featuring new rewritten Xen Project support based on the upstream (kernel.org) Linux pvops framework. This work has been included in upstream kernel.org kernel since Linux 2.6.37.
  • xenlinux kernels based on the "old" patches originally for Linux 2.6.18. These xenlinux patches won't be integrated to upstream Linux.

However, the pv_ops kernel requires Xen Project >=4.0. If you desperately need the Xenlinux patches, SLES/OpenSUSE has been forward-porting the patches.

Personal tools